<template>
  <div
    class="modal-wrapper"
    v-if="isModalShown"
    @click.self="closeModal"
  >
    <div class="modal settings-modal">
      <div class="settings-modal-inputs">
        <div class="settings-modal-fields">
          <label for="offset">
            <span>Смещение даты</span>
          </label>
          <input
            class="offset"
            id="offset"
            v-mask="{regex: '-?[0-9]*'}"
            :value="settings.offset"
            @input="onInput('offset', +$event.target.value)"
          >
        </div>
        <div class="settings-modal-fields">
          <label for="workingDays">
            <span>Колличество рабочих дней</span>
          </label>
          <input
            class="workingDays"
            id="workingDays"
            v-mask="{regex: '[1-9][0-9]*'}"
            :value="settings.workingDays"
            @input="onInput('workingDays', +$event.target.value)"
          >
        </div>
        <div class="settings-modal-fields">
          <label for="nonWorkingDays">
            <span>Колличество выходных</span>
          </label>
          <input
            class="nonWorkingDays"
            id="nonWorkingDays"
            v-mask="{regex: '[1-9][0-9]*'}"
            :value="settings.nonWorkingDays"
            @input="onInput('nonWorkingDays', +$event.target.value)"
          >
        </div>
      </div>
      <button
        class="modal-submit"
        @click="saveSettings"
      >
        Сохранить
      </button>
    </div>
  </div>
</template>

<script>
import moment from 'moment';

export default {
  name: 'settingsModal',

  props: {
    startingDate: {
      type: String,
      default: '',
    },
    isModalShown: {
      type: Boolean,
      default: false,
    },
    settings: {
      type: Object,
      default: () => {},
    },
  },

  data() {
    return {
      form: {},
    };
  },

  watch: {
    settings: {
      handler() {
        this.form = { ...this.settings };
      },
      immediate: true,
      deep: true,
    },
  },

  computed: {
    getAmountOfDaysToToday() {
      const date = `${moment(this.date).format('YYYY-MM-DD')}`;
      return moment(date, 'YYYY-MM-DD').diff(this.startingDate, 'days') + 1;
    },
  },

  methods: {
    onInput(field, value) {
      this.form[field] = value;
    },

    closeModal() {
      this.$emit('closeModal');
    },

    saveSettings() {
      if (this.form.offset < this.getAmountOfDaysToToday - 30
        && this.form.workingDays !== 0
        && this.form.nonWorkingDays !== 0) {
        this.$emit('saveSettings', this.form);
        this.closeModal();
      }
    },
  },
};
</script>
